︠bdbb3646-99e4-48ca-9ba8-8f2fed0f86fci︠
%md
# Math 152: Intro to Mathematical Software
### 2017-01-20
### Kiran Kedlaya; University of California, San Diego
### adapted from lectures by William Stein, University of Washington

## **Lecture 5: Dicts and Classes **

### Guest lecturer: [William Stein](http://wstein.org) (Professor, University of Washington; CEO, SageMath Inc.)

︡70e03e40-9a05-428f-83b3-b56d801d9744︡{"done":true,"md":"# Math 152: Intro to Mathematical Software\n### 2017-01-20\n### Kiran Kedlaya; University of California, San Diego\n### adapted from lectures by William Stein, University of Washington\n\n## **Lecture 5: Dicts and Classes **\n\n### Guest lecturer: [William Stein](http://wstein.org) (Professor, University of Washington; CEO, SageMath Inc.)"}
︠d1c71866-fbba-486f-bb07-3a6a3714abd8i︠
%md
## Another important data structure: the Python dictionary

A Python dictionary is the Python version of what computer scientists might call an "associative array".

It's what us mathematicians call a "function" from one finite set to another ( not to be confused with a Python "function", which is really a subroutine).
︡14f4f227-7e2f-4233-81ca-3ec3dee9973e︡{"done":true,"md":"## Another important data structure: the Python dictionary\n\nA Python dictionary is the Python version of what computer scientists might call an \"associative array\".\n\nIt's what us mathematicians call a \"function\" from one finite set to another ( not to be confused with a Python \"function\", which is really a subroutine)."}
︠24b6a5ad-73f2-404b-82b6-c118f6ce4cces︠
def foo(n): ## A Python function, not a mathematical function
    return random()
︡971e397b-2fce-4bbc-ad9c-f0fdc1f11dfd︡{"done":true}︡
︠1745df9b-c080-4242-95b9-d47d5c3e7c0es︠
foo(5)
︡d365e5a3-803b-48f8-809b-0fe98c0a5327︡{"stdout":"0.3704000361759935\n"}︡{"done":true}︡
︠925acc57-7549-4e1d-aaae-bc39079ba8fds︠
foo(5)
︡3eddf348-23b7-4491-bc38-f95e18175159︡{"stdout":"0.8220957522968851\n"}︡{"done":true}︡
︠8ffe6908-b74b-47e8-8cd9-fcdaf609fdd0s︠
d = {5:25, 10:100, 3:8, 3:'another value'}
︡771cadc1-684b-480c-ad30-af4070a301b3︡{"done":true}︡
︠3cf1ddfc-81da-49f8-a3e7-134484d6dc10s︠
d
︡6675cb62-2310-4158-9437-391d36e62c3b︡{"stdout":"{10: 100, 3: 'another value', 5: 25}\n"}︡{"done":true}︡
︠1f1daabd-5993-46d7-a09a-5a55e1f6d77cs︠
d[10] # You can change existing values...
︡c125b5cf-7723-430e-a561-6d0999b9bcec︡{"stdout":"100\n"}︡{"done":true}︡
︠c3443af9-4ab0-440c-bf26-ed40db8fcf14s︠
d[5]
︡39c2a978-bbd6-489f-813c-80dc2ebfb1c4︡{"stdout":"25\n"}︡{"done":true}︡
︠ed7eabbc-b377-4a8d-a68f-add83b9952ccs︠
d[10] = 'foo bar'
︡88d47af3-ddcc-461f-93d2-cdcc512246b8︡{"done":true}︡
︠97ee6a79-f241-42e4-b5cc-8396a04576b8s︠
d[10]
︡1b4caa42-b60f-42ed-8a21-b5cf56623f47︡{"stdout":"'foo bar'\n"}︡{"done":true}︡
︠5ed5c87b-cee2-454c-b08a-37e1a4dbde5es︠
d[9] = 0 # Or create new ones...
print(d)
︡8ef9375c-1549-4d0f-861e-3383d72b9574︡{"stdout":"{9: 0, 10: 'foo bar', 3: 'another value', 5: 25}\n"}︡{"done":true}︡
︠f11b1272-4b57-4a5b-888b-e3bca75c512as︠
d
︡a2e9734a-32a7-47e9-99b9-43a0b45f8ef9︡{"stdout":"{9: 0, 10: 'foo bar', 3: 'another value', 5: 25}\n"}︡{"done":true}︡︡{"done":true}
︠acfdb040-a61b-4fa6-8af8-605512eb2adas︠
for a in d.keys():
    print id(a)
︡b4c1826b-acde-420d-9fbf-197fea7120f6︡{"stdout":"139756685828336\n139756685828240\n139756685828480\n139756685828576\n"}︡{"done":true}
︠18c7f593-076e-4ee0-ac59-6e9e8a2b3801s︠
d[5]
︡d8955b29-9542-4489-ad74-f1003a0ea2d7︡{"stdout":"25\n"}︡{"done":true}
︠eb2af520-e927-43e1-ae15-f0e001a58840s︠
d[10]
︡68b1138d-0f01-4fca-830a-4f2d0f0af1b6︡{"stdout":"'foo bar'\n"}︡{"done":true}︡
︠7f9489d4-664c-441c-b378-e905e9b0ea8cs︠
d[3]
︡e93348ea-6cd4-402c-8c75-2b19e6303366︡{"stdout":"'another value'\n"}︡{"done":true}
︠159813f9-381b-46bd-a8e2-19c07ca019e1s︠
d[7]  # should fail -- since we didn't say what 7 maps to.
︡8188259d-e512-4042-9956-7972e3aeb129︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/projects/sage/sage-7.3/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nKeyError: 7\n"}︡{"done":true}︡
︠36d28816-5ad0-4af7-9f6b-252d1bc66023s︠
d['william stein']
︡48ef9513-cd06-4900-ba3c-1d05f71dfb60︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/projects/sage/sage-7.3/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nKeyError: 'william stein'\n"}︡{"done":true}︡
︠6380ee1e-6b4a-4de7-9202-2f9102934d98i︠
%md
Aside: Python has a form of flow control for catching runtime errors.
︡397766b2-4407-45b2-9963-bf63a8bd187b︡{"done":true,"md":"Aside: Python has a form of flow control for catching runtime errors."}
︠12f92a64-769e-40ca-91f0-1c6eb64f1579s︠
try:
    d[7]
except KeyError:
    print "there was an error"
︡be95d960-50d4-49c6-b7e7-69bcfe6ec13c︡{"stdout":"there was an error\n"}︡{"done":true}
︠262300df-327f-4a31-8021-9b422a280c2fs︠
try:
    print d[10]
except KeyError:
    print "there was an error"
︡8d0e719c-c758-4666-b82f-cd9e1382006a︡{"stdout":"foo bar\n"}︡{"done":true}︡
︠f4d099dc-227b-46e3-bfb1-d5312f63448fi︠
%md
You can also use `get` and specify a default if there is no key in the dict
︡e3679394-4764-4801-bc28-de4553568fd5︡{"done":true,"md":"You can also use `get` and specify a default if there is no key in the dict"}
︠3551931d-7e30-4bc4-92d9-af545472e363s︠
c[10]
︡4e29ca79-89f0-4be7-87e4-61a83943baf1︡
︠e1c2c66e-2a17-44a8-a866-a3b8bb137b97︠
︡b36464ea-a21f-4aa5-ab25-6148a7eea4f6︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/projects/sage/sage-7.3/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nNameError: name 'c' is not defined\n"}︡{"done":true}︡
︠9c4fde49-b7b3-4195-8dcc-97c775268e44︠
d.
︡86f8dc93-ffaf-465a-83b6-1c832cc7efb7︡
︠450fc67c-1e4e-4202-b00a-4a7da6d3131ds︠
d[7]
︡60fdd488-188a-4ae1-9933-59d45a0c8501︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/projects/sage/sage-7.3/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nKeyError: 7\n"}︡{"done":true}︡
︠4ae6df35-bec1-4a5b-bd74-9be50a84dde5s︠
d.get(7, 'default_value')
︡42d8263f-e265-424e-a2bc-c754c61f35e6︡{"stdout":"'default_value'\n"}︡{"done":true}︡
︠afe967ab-9ffa-4f43-ab1b-02942e99f093s︠
7 in d
︡ace45d34-3c61-4c19-983e-43b321a21435︡{"stdout":"False\n"}︡{"done":true}︡
︠0190e1b7-b856-46fb-b30c-a908a2ed58cds︠
n = 930980348028348
︡5a3a34dd-3408-4d46-8e1a-95fe25201def︡{"done":true}︡
︠aa86b378-df8d-453d-956d-333ae583ad26s︠
"error %s is not prime"%n
︡d4f6ae0d-5d11-4813-969a-87e81037f744︡
︠91110ee8-1e7a-4ea4-a086-b4338cfc4974︠
︡60c1361d-9fb3-4a8c-a86a-25fdf01585b9︡{"stdout":"'error 930980348028348 is not prime'\n"}︡{"done":true}︡
︠dd9611e8-6142-4752-975c-8bad8375eb6di︠
%md
The keys (inputs) of a Python dictionary can be any object x in Python where `hash(x)` doesn't give an error.

In practice, `hash(x)` is supposed to work if and only if `x` is **immutable**, i.e., really can't change.
︡95bd0d19-279e-4cce-901d-0b255a9194e9︡{"done":true,"md":"The keys (inputs) of a Python dictionary can be any object x in Python where `hash(x)` doesn't give an error.\n\nIn practice, `hash(x)` is supposed to work if and only if `x` is **immutable**, i.e., really can't change."}
︠8cbe7124-0537-4520-b387-9a306c85224cs︠
s = 'lksdjfljsdfljasdfj'
︡6adb00d0-ecac-423f-9bec-0c91f91a00fa︡{"done":true}︡
︠294ebff5-8129-400f-9664-1d379fa0ea8es︠
s[4]
︡b0b82cc0-7548-4652-bd78-4d2c50937272︡{"stdout":"'j'\n"}︡{"done":true}︡
︠eac7bf28-5716-47f9-a1f9-149a284cdfe9s︠
s[4] = 'Y'
︡b76d4135-696b-4266-aae7-fa9f4d8ba624︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/projects/sage/sage-7.3/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nTypeError: 'str' object does not support item assignment\n"}︡{"done":true}︡
︠5d843b8c-c518-427d-8f98-874b9318270bs︠
hash(7)
︡bf1430a1-84a7-45f2-ad63-841d0bf4eea4︡{"stdout":"7\n"}︡{"done":true}
︠d3fc570b-f451-46f1-b719-3d29f753097bs︠
w = [2,3]
hash(w)   # better not work!
︡e96cdd55-f78b-409f-be3b-7b5026634876︡{"stderr":"Error in lines 2-2\nTraceback (most recent call last):\n  File \"/projects/sage/sage-7.3/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nTypeError: unhashable type: 'list'\n"}︡{"done":true}︡
︠1651c145-4a94-4167-8637-d960f3286e7di︠
%md
We saw tuples briefly in the previous lecture.

Tuples are sort of like lists, but you can't change the objects they point to or the number of things they point to.

Hence... **they have a chance to be immutable:**
︡cd8f5601-95e3-4a67-aa1c-7cc1ed4b3d0d︡{"done":true,"md":"We saw tuples briefly in the previous lecture.\n\nTuples are sort of like lists, but you can't change the objects they point to or the number of things they point to.\n\nHence... **they have a chance to be immutable:**"}
︠629db280-8471-4075-9a4b-024a42731b2cs︠
d = {5:'a',   [2,3]:5}
︡fab062e8-62fc-4506-bff6-6a89f1888984︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/projects/sage/sage-7.3/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nTypeError: unhashable type: 'list'\n"}︡{"done":true}︡
︠5f220171-d08b-4801-9ccd-43625aef0c27s︠
s = 'abc'
t = ['a', 'b', 'c']
s[2]
t[2]
︡618bbae7-3dfe-439c-8715-334d785d728d︡{"stdout":"'c'\n"}︡{"stdout":"'c'\n"}︡{"done":true}︡
︠10697918-e46c-4804-bb53-01eb5478ee81s︠
t[2] = 'x'
s[2] = 'x'
︡aa9910c3-1f3f-4b53-9143-559200534df7︡{"stderr":"Error in lines 2-2\nTraceback (most recent call last):\n  File \"/projects/sage/sage-7.3/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nTypeError: 'str' object does not support item assignment\n"}︡{"done":true}︡
︠c116d166-c9b6-4e99-8e26-4dca56085fe6s︠
t
︡d2ccec50-2b8b-4bcf-8489-36debbacbf77︡{"stdout":"['a', 'b', 'x']\n"}︡{"done":true}︡
︠6015af29-bb2c-471b-941f-47a31a3e554es︠
list(s)
︡d35f7e12-d860-4c81-8cd5-1fa50bd3e2ee︡{"stdout":"['a', 'b', 'c']\n"}︡{"done":true}︡
︠d5c281f5-49d8-4bd7-b00e-527bd9a8a1efs︠
x = [2,3]
d[x]
︡4e98741c-ff12-49a8-adeb-7095d1d1905b︡{"stderr":"Error in lines 2-2\nTraceback (most recent call last):\n  File \"/projects/sage/sage-7.3/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nTypeError: unhashable type: 'list'\n"}︡{"done":true}︡
︠893a8827-7fdd-4df1-a191-d31bdd0fc83fs︠
hash([2,3])
︡76a9fe46-da54-41bd-b3fd-ec900c973934︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/projects/sage/sage-7.3/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nTypeError: unhashable type: 'list'\n"}︡{"done":true}︡
︠7e53d595-f31c-43a4-b7fe-0d1d45c88496s︠
w = (2,3)
hash(w)    # a tuple where each thing in the tuple is immutable
︡39da1aca-bee8-4034-a1b1-d0cf5387a457︡{"stdout":"3713082714463740756\n"}︡{"done":true}︡
︠c65b6e45-bc62-4049-9404-4ccf056deae4s︠

︡e420721b-0bd4-4b6a-986a-29feb14e91e0︡{"done":true}︡
︠4f50157b-145f-40a3-86c9-dba986cd5f9bs︠
d = {(2,3):5,   (7,19): 26}   # you can use anything immutable as the inputs (or keys or domain)
d[(7,19)]
︡bbbadb78-a89f-4112-83da-8979807a0342︡{"stdout":"26\n"}︡{"done":true}︡
︠18608d49-189f-4eb4-b3b0-1d1f8d986fd2i︠
%md
Not all tuples are immutable.  For example:
︡1080ca5b-c591-4b96-bf2a-e16cc496c68b︡{"done":true,"md":"Not all tuples are immutable.  For example:"}
︠070ad738-e402-4f09-9ce9-4e978fd9ba65s︠
w = ([2,3], 5)   # a tuple where first thing is NOT immutable
hash(w)
︡5a820abe-16e0-4b3c-9d48-4ea2703eb699︡{"stderr":"Error in lines 2-2\nTraceback (most recent call last):\n  File \"/projects/sage/sage-7.3/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nTypeError: unhashable type: 'list'\n"}︡{"done":true}︡
︠c3046dd4-c2d1-4635-a276-fcfb504ec790s︠
id(w[0])
︡69a08d1f-86c6-40eb-95dd-56b86082c893︡{"stdout":"139756685803672\n"}︡{"done":true}︡
︠d350b0a3-07f6-4911-a703-6a9af962b8c9s︠
w[0].append("Sage")
w
︡04e79892-b053-4b94-bf1d-b7ff2f6efc94︡{"stdout":"([2, 3, 'Sage'], 5)\n"}︡{"done":true}︡
︠cd27f405-4b25-40b9-abe7-7927aaf777a6s︠
id(w[0])
︡7c2e7736-e389-4919-92ef-ab6f6fb65758︡{"stdout":"139756685803672\n"}︡{"done":true}︡
︠b3dbbbb6-e046-4a64-bdb1-32eaab8f17f6︠

︡3b55cd51-cf95-4eb7-9a21-36a50b6c1454︡︠0bfe2765-7f03-487a-92bd-359d55e8a14f︠
︠d69767d1-ea3c-4e8b-8960-5d3d67a048ba︠

︡7decef29-0658-4773-a98c-63d22176a7d1︡︠1db8724a-5404-4e76-822d-684a237974ed︠
︠d8e6caf9-1227-463b-a536-9806bd5fba3b︠

︡591b1cf7-bef4-4b90-9158-35d7edfa246d︡
︠dcaa834d-9cc8-4db7-83de-f50b6cebed84i︠
%md

**Exercise:** Which of the following are immutable, i.e., `hash`-able, so they can be used as keys for a dictionary?

- the string "Foo"

- the empty list []

- the number 3.14

- the dictionary {7:10, 3:8}

- the tuple ('foo', 'bar')

Make a dictionary that has all the immutable objects above as keys... and anything you want (hashable or not) as values.
︡7493f29b-0539-4c27-822a-e621603571bd︡{"done":true,"md":"\n**Exercise:** Which of the following are immutable, i.e., `hash`-able, so they can be used as keys for a dictionary?\n\n- the string \"Foo\"\n\n- the empty list []\n\n- the number 3.14\n\n- the dictionary {7:10, 3:8}\n\n- the tuple ('foo', 'bar')\n\nMake a dictionary that has all the immutable objects above as keys... and anything you want (hashable or not) as values."}
︠d8249bb0-71be-48d1-9a26-fc1ee9e68810s︠
hash("Foo")   # no error <===> it's immutable
︡8fc5d440-d237-4d3c-8828-1809e51d3572︡{"stdout":"-5036909580522842981\n"}︡{"done":true}︡
︠87c2b980-c0c7-45d0-8f2e-677788776e83s︠

d = {"Foo":(1,2), 3.14:5}  # IS A DICTIONARY


︡058f29e2-c0a0-4ca5-8c7a-47a434af3197︡{"done":true}︡
︠428a7395-6738-4fba-85ca-888522b98c33s︠
type(d)
︡a6a3fe0f-fd56-4360-aab1-b39814c1f719︡{"stdout":"<type 'dict'>\n"}︡{"done":true}︡
︠f3956db1-2249-4397-b71e-a398457064ffs︠
d
︡c4c32844-f097-41b1-98c6-bc55bff618b0︡{"stdout":"{'Foo': (1, 2), 3.14000000000000: 5}\n"}︡{"done":true}︡
︠08e50a25-2b3c-4541-a4a3-21f09c940b0cs︠
hash(d)

︡008950ed-bbb6-4c86-a3ce-c87d9f8cd78d︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/projects/sage/sage-7.3/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nTypeError: unhashable type: 'dict'\n"}︡{"done":true}︡
︠57b6f2b5-2a9a-4a85-a030-dfe206d4ad15i︠
%md
Here's a dictionary with a Python *function* as a value:
︡0de673e0-255e-417e-b039-70f455483798︡{"done":true,"md":"Here's a dictionary with a Python *function* as a value:"}
︠c81d36d9-3764-493a-b8bc-946d9339eb1as︠
def length(self):
    return sqrt(self['x']^2 + self['y']^2)

self = {'x':10,  'y':25,  'length':length}
self
︡ae0ac021-6c30-4f28-afe3-337d94c49394︡{"stdout":"{'y': 25, 'x': 10, 'length': <function length at 0x7f1ba39bbe60>}\n"}︡{"done":true}︡
︠4c7cc51c-54c1-46ff-8ce1-b76b7576ed42s︠
hash(length)
{length:10, 'x':5}
︡746f08f7-30a9-40a8-a3e1-7d5a44fa4815︡{"stdout":"8734792858598\n"}︡{"stdout":"{'x': 5, <function length at 0x7f1ba39bbe60>: 10}\n"}︡{"done":true}︡
︠a7c9427d-f8f5-4db8-857c-4e4af4f6f6a4s︠
self['length'](self)
︡4ea6257f-594d-4672-97f1-061ccce04599︡{"stdout":"5*sqrt(29)\n"}︡{"done":true}︡
︠f683b6b3-a9b6-4115-8574-38fafc2b5f54i︠
%md
Using dicts with data and functions, you could try to model mathematical objects and work with them.

But the notation is very awkward!

Python classes do much the same thing, with vastly nicer notation!
︡a2252da7-8e39-4c81-a7e9-161a73b672e7︡{"done":true,"md":"Using dicts with data and functions, you could try to model mathematical objects and work with them.\n\nBut the notation is very awkward!\n\nPython classes do much the same thing, with vastly nicer notation!"}
︠352e986e-5321-4508-99ca-def6711b7a77s︠

︡43c5d12e-3d05-4c2f-a6b1-1c5d6078c5c1︡{"done":true}︡
︠f4dd5f00-1a75-4cc5-9eca-2d84a91d360bi︠
%md
## Python Classes

Python classes let you easily create custom Python objects.  They are a fantastic way of organizing math-related code (as well as many other types of code).

Example:
︡82badfc5-4b7c-4e83-a4b1-c848d949d537︡{"done":true,"md":"## Python Classes\n\nPython classes let you easily create custom Python objects.  They are a fantastic way of organizing math-related code (as well as many other types of code).\n\nExample:"}
︠0b2d4358-f2c8-481f-a4d7-a71311a2a597s︠
class Vector:
    def __init__(self, x, y):
        self.x = x
        self.y = y
        print "I just initialized myself"
    def length(self):
        print "hi this is length"
        return sqrt(self.x^2 + self.y^2)
    def __add__(self, right):
        return Vector(self.x+right.x, self.y + right.y)
        # change to Vector3
    def __repr__(self):
        return "(%s, %s)"%(self.x, self.y)

︡cfb5cb20-c355-4392-b589-53acd20d7898︡{"done":true}︡
︠5e7d82e7-4e39-4b5e-b689-77908ea0ff6ds︠
v = Vector(e, pi)
v
︡2662c101-035b-49d9-8a23-37e4cdb4706b︡{"stdout":"I just initialized myself\n"}︡{"stdout":"(e, pi)\n"}︡{"done":true}︡
︠fa3c80ff-92d8-4f17-b228-6935f99e5477s︠
type(pi)
︡28ffffbc-53b1-41e9-8240-73d8d1e9fecb︡{"stdout":"<type 'sage.symbolic.expression.Expression'>\n"}︡{"done":true}︡
︠94f7ad25-f799-4d58-b96a-86b7c52be40ds︠
%time s = pi.N(digits=10^6)
︡0b7def46-72cb-42f3-a1c3-672ab127bd4d︡{"stdout":"CPU time: 2.16 s, Wall time: 2.20 s"}︡{"stdout":"\n"}︡{"done":true}
︠8ba066fa-ba39-4cb6-9785-59db27160a6as︠
v = Vector(3,4)
v
︡ba485bfa-ad66-495a-995f-711e3b8c20c2︡{"stdout":"I just initialized myself\n"}︡{"stdout":"(3, 4)\n"}︡{"done":true}︡
︠9bebd131-29a7-4a04-bac3-95aa7cb086d4s︠
v.length()
︡93434b90-dca1-464d-b251-838ced9fd7ea︡{"stdout":"hi this is length\n5\n"}︡{"done":true}︡
︠2fca90ba-c38b-4752-ba88-f86c49fd20dbs︠
s = e + pi + sqrt(2)
type(s)
︡b4b13401-bf68-4318-a4ba-d54d61af48cd︡{"stdout":"<type 'sage.symbolic.expression.Expression'>\n"}︡{"done":true}︡
︠2a6f8c6f-c4b9-484c-95de-c336023a2709︠
︡3c370178-1111-43b7-9f07-29b615bb1360︡
︠1f0c7ea0-5e50-4d33-8c20-8abfb52b630as︠
type(s.N(100))
︡6f093461-fd5a-44e7-99ff-078d489ae325︡{"stdout":"<type 'sage.rings.real_mpfr.RealNumber'>\n"}︡{"done":true}︡
︠85edae7e-c649-4699-ab09-3a2e457f5584s︠
v = Vector(e, pi)
︡741cc700-17ff-4746-a2ef-47d8105ea69e︡{"stdout":"I just initialized myself\n"}︡{"done":true}︡
︠4ffdbb58-0b2b-48df-9891-418519285ea2s︠
s = v.length()
s
︡0e71c9c0-a192-4e82-83dd-add8d2cd43e5︡{"stdout":"hi this is length\n"}︡{"stdout":"sqrt(pi^2 + e^2)\n"}︡{"done":true}︡
︠535f488f-1a5e-4db1-916c-9e2a10093212s︠
s.N(digits=100)
︡daa68c97-d1d8-43a8-8763-2aa1ae501a78︡{"stdout":"4.154354402313313572948121466679053097883112964956925650570131181071504645063424705663305915070972059\n"}︡{"done":true}︡
︠ddbd6b08-a0bf-43f3-93ac-564a67dfa584s︠
v.x
︡360562f0-19f3-414d-836a-779b956a007e︡{"stdout":"e\n"}︡{"done":true}︡
︠fcec2042-fb90-4b7d-9149-d1efc0484200s︠
v.y
︡bef317ee-b83c-4c9b-b7ed-89f340bd05cb︡{"stdout":"pi\n"}︡{"done":true}︡
︠153dd7d9-12cc-4bde-b875-1ce0d4232bd5s︠
v.length()
︡fe2301bd-0822-4be6-b501-d24cea488d6f︡{"stdout":"hi this is length\nsqrt(pi^2 + e^2)\n"}︡{"done":true}︡
︠c459adf0-9eba-482a-b9a1-f7bf1e11c66bs︠
v + v
︡16e7709f-ac20-49a7-9a83-605e632eae12︡{"stdout":"I just initialized myself\nWilliam's vector (2*e, 2*pi)\n"}︡{"done":true}︡
︠0997ba1a-5a90-4356-988f-755ac0ac3355s︠
v.__dict__
︡ab638484-e0c1-4d80-a3dc-8d039f0528ff︡{"stdout":"{'y': pi, 'x': e}\n"}︡{"done":true}︡
︠13e278cd-28eb-48ca-a6b1-7ec8ccf1ca1di︠
%md

**Exercise:**

Copy the above code and make a class Vector3 that models a vector in 3-dimensional space.

If you have time, also include a `__sub__` method, to subtract one vector from another, and test that v - w works.
︡4f8204a4-4314-4a77-b634-bb1bd4e86d2d︡{"done":true,"md":"\n**Exercise:**\n\nCopy the above code and make a class Vector3 that models a vector in 3-dimensional space.\n\nIf you have time, also include a `__sub__` method, to subtract one vector from another, and test that v - w works."}
︠e997cc80-9b13-4aff-b8bb-2b1342f66dbb︠
v.cross_product(w)   # add an implementation of this (it's fine if you have to look it up...)
︡65e5b77d-d777-4e3e-b333-81ff027a834f︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/projects/sage/sage-7.3/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nAttributeError: Vector instance has no attribute 'cross_product'\n"}︡{"done":true}︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/projects/sage/sage-7.3/local/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 976, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nAttributeError: Vector instance has no attribute 'cross_product'\n"}︡{"done":true}










